<template>
  <div class="box"
       v-show="position.visible"
       ref="draggableContainer"
       :style="{
           left: `${position.x}px`,
           top: `${position.y}px`,
           width: `${position.width}px`,
           height: `${position.height}px`,
           'z-index': position.z
         }">

    <div class="box-title" @mousedown="dragMouseDown">
      <h5>{{ title }}</h5>
      <div class="box-tools">
        <button @click="close()" class="box-tools-link fas fa-times"></button>
      </div>
    </div>

    <section class="box-content">
      <slot></slot>
    </section>

    <resizer @resize="onResize"/>
  </div>
</template>

<script lang="ts">
  import {Component, Prop, Vue} from 'nuxt-property-decorator';
  import {Position} from '~/types/windows';
  import {SET_POSITION, GET_POSITION, SELECT_WINDOW} from '~/store/windows';
  import Resizer from '~/components/Resizer.vue';
  import config from '~/configs';

  @Component({
    components: { Resizer }
  })
  export default class UiKitWindow extends Vue {
    @Prop({default: ''}) title?: string;
    @Prop({required: true}) index: number;

    public $refs: Vue['$refs'] & {
      draggableContainer: HTMLDivElement
    };

    private clientX: number = 0;
    private clientY: number = 0;

    get position(): Position {
      return this.$store.getters[GET_POSITION](this.index);
    }

    public close() {
      this.$store.commit(SET_POSITION, {
        index: this.index,
        value: { visible: false }
      });
    }

    public onResize(event) {
      const newWidth = this.$refs.draggableContainer.offsetWidth - event.width;
      if ((newWidth >= config.windows.minWidth) && (Math.abs(event.width) >= config.gridSize)) {
        this.$store.commit(SET_POSITION, {
          index: this.index,
          value: { width: Math.floor(newWidth / config.gridSize) * config.gridSize }
        });
      }

      const newHeight = this.$refs.draggableContainer.offsetHeight - event.height;
      if ((newHeight >= config.windows.minHeight) && (Math.abs(event.height) >= config.gridSize)) {
        this.$store.commit(SET_POSITION, {
          index: this.index,
          value: { height: Math.floor(newHeight / config.gridSize) * config.gridSize }
        });
      }
    }

    protected dragMouseDown(event) {
      event.preventDefault();

      this.clientX = event.clientX;
      this.clientY = event.clientY;

      this.$store.commit(SELECT_WINDOW, this.index);

      document.onmousemove = this.elementDrag;
      document.onmouseup = this.closeDragElement;
    }

    protected elementDrag(event) {
      event.preventDefault();

      const newXPosition = this.$refs.draggableContainer.offsetLeft - this.clientX + event.clientX;

      if ((newXPosition >= 0) && (Math.abs(this.clientX - event.clientX) >= config.gridSize)) {
        this.$store.commit(SET_POSITION, {
          index: this.index,
          value: { x: Math.floor(newXPosition / config.gridSize) * config.gridSize }
        });

        this.clientX = event.clientX;
      }

      const newYPosition = this.$refs.draggableContainer.offsetTop - this.clientY + event.clientY;

      if ((newYPosition >= 0) && (Math.abs(this.clientY - event.clientY) >= config.gridSize)) {
        this.$store.commit(SET_POSITION, {
          index: this.index,
          value: { y: Math.floor(newYPosition / config.gridSize) * config.gridSize }
        });

        this.clientY = event.clientY;
      }
    }

    protected closeDragElement() {
      document.onmouseup = null;
      document.onmousemove = null;
    };
  }
</script>
